'use strict';

var fs = require('fs');
var init = require('../src/commands/init');
var install = require('../src/commands/install');

exports.testIntall = function(test) {
	test.expect(2);

    var log = [];
    var oldConsoleLog = console.log;
    console.log = function() {
        log.push([].slice.call(arguments));
    };
	
	install();
	test.equal(log[0], 'The setitup.config file doesn\'t exist');

	init();

	//try to install command namespace
	log = [];
	install(void(0), void(0), 'commands');
	test.equal(log[0], "\u001b[32m-->\u001b[37m Processing commands\u001b[0m");

    //remove setitup.config test file generated by init command
    fs.unlinkSync(process.cwd() + '/setitup.config');
    console.log = oldConsoleLog;

    test.done();
};